;;; Sierra Script 1.0 - (do not remove this comment)
(script# 70)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use ThrowFlameDart)
(use ThrowDagger1)
(use AnimateCalm)
(use AnimateDazzle)
(use Interface)
(use LoadMany)
(use Sound)
(use Save)
(use Motion)
(use Game)
(use Inventory)
(use User)
(use Actor)
(use System)

(public
	rm70 0
)

(local
	local0
	fairiesOnScreen
	theNewAFaeryWindow
	local3
	local4
	[local5 8]
	[local13 8] = [62 119 91 145 134 104 75 40]
	[local21 8] = [109 108 108 107 101 98 97 101]
	[newAFaery 5]
	[local34 5] = [74 143 52 90 110]
	[local39 5] = [109 120 122 99 108]
	[local44 5] = [1 11 6 5 8]
	[local49 5] = [14 2 10 15 12]
	[newAFaeryWindow 5]
	[newAFaeryScript 5]
	[local64 5]
	local69
	[local70 5] = [35 250 265 140 225]
	[local75 5] = [30 35 125 50 45]
	local80
	local81
	local82
	local83
	local84
	local85 =  137
	local86 =  137
	local87
	local88
	local89 =  -1
	local90
	local91 =  13
	local92 =  22
	local93 =  32
	local94 =  38
	local95 =  47
	local96 =  59
	local97 =  69
	local98 =  78
	local99 =  100
	local100 =  104
	local101 =  113
	local102 =  121
	local103 =  128
	local104 =  135
	local105 =  141
	local106 =  151
	local107
	local108
	local109
	mushroomPalette
	local111
)
(procedure (localproc_000c &tmp temp0)
	(= temp0 0)
	(while (< temp0 5)
		(= [newAFaeryWindow temp0] (aFaeryWindow new:))
		(if (< colourCount 8)
			([newAFaeryWindow temp0] color: 0 back: 15)
		else
			([newAFaeryWindow temp0]
				color: [local44 temp0]
				back: [local49 temp0]
			)
		)
		(++ temp0)
	)
)

(procedure (FairySays param1 &tmp temp0 temp1)
	(= theNewAFaeryWindow [newAFaeryWindow (Random 0 4)])
	(= temp0 (Random 5 210))
	(= temp1
		(if (< (ego y?) 140)
			(Random (ego y?) 140)
		else
			(Random 5 (- (ego y?) 80))
		)
	)
	(DisposeDialog)
	(Print
		&rest
		#at temp0 temp1
		#width 100
		#mode 1
		#dispose
		#time param1
		#window theNewAFaeryWindow
	)
)

(procedure (localproc_00c8 &tmp temp0)
	(Bset GOT_FAIRIES_ATTENTION)
	(= temp0 0)
	(while (< temp0 5)
		([newAFaery temp0]
			setStep: 6 4
			setScript: [local64 temp0] 0 (= [local64 temp0] (Clone aChaseScript))
		)
		(++ temp0)
	)
)

(procedure (localproc_0106 &tmp temp0)
	(Bclr GOT_FAIRIES_ATTENTION)
	(= temp0 0)
	(while (< temp0 5)
		([newAFaery temp0]
			setStep: 3 2
			setScript:
				[newAFaeryScript temp0]
				0
				(= [newAFaeryScript temp0] (aFaeryScript new:))
		)
		(++ temp0)
	)
)

(procedure (localproc_0143 &tmp temp0 temp1)
	(if fairiesOnScreen
		(Bclr GOT_FAIRIES_ATTENTION)
		(= local69 80)
		(= temp0 0)
		(while (< temp0 5)
			(= [newAFaeryScript temp0] (aFaeryScript new:))
			(= temp1 (Random 0 4))
			([newAFaery temp1]
				posn: [local70 temp1] [local75 temp1]
				setScript: [newAFaeryScript temp0] 0 temp1
			)
			(++ temp0)
		)
	)
)

(procedure (localproc_0193 &tmp temp0)
	(= temp0 0)
	(while (< temp0 5)
		([newAFaery temp0]
			setLoop: temp0
			cel: 0
			ignoreActors:
			ignoreHorizon:
			posn:
				[local34 temp0]
				[local39 (= [newAFaeryScript temp0] (aFaeryScript new:))]
			init:
			setCycle: Forward
			setScript: [newAFaeryScript temp0] 0 (= [newAFaery temp0] (aFaery new:))
		)
		(++ temp0)
	)
)

(procedure (localproc_025c &tmp temp0)
	(= temp0 0)
	(while (< temp0 8)
		([local5 temp0]
			setLoop: 5
			setCel: temp0
			posn: [local13 temp0] [local21 (= [local5 temp0] (Clone aMush))]
			init:
			stopUpd:
		)
		(++ temp0)
	)
)

(instance aFaery of Actor
	(properties
		z 25
		view 70
		illegalBits $0000
	)
)

(instance aMush of View
	(properties
		view 70
	)
)

(instance aFaeryWindow of SysWindow
	(properties)
)

(instance faeryMusic of Sound
	(properties
		number 40
		priority 1
		loop -1
	)
)

(instance egoBoogie of Sound
	(properties
		number 49
		priority 2
		loop -1
	)
)

(instance bopTilYouDrop of Sound
	(properties
		number 64
		priority 2
		loop -1
	)
)

(instance rm70 of Room
	(properties
		picture 70
		style $0000
		horizon 74
		north 62
		east 71
		south 77
		west 69
	)
	
	(method (init)
		(if (= fairiesOnScreen isNightTime)
			(LoadMany 128 70 71)
			(Load rsTEXT 296)
			(LoadMany 132 40 64)
		)
		(LoadMany 128 510 72)
		(if fairiesOnScreen
			(localproc_0193)
			(localproc_000c)
			(gKeyHandler add: self)
			(gMouseHandler addToFront: self)
			(gDirHandler add: self)
			(cSound stop:)
			(faeryMusic init: play:)
			(egoBoogie init:)
			(bopTilYouDrop init:)
		else
			(= local3 1)
			(= defaultPalette 0)
		)
		(localproc_025c)
		(super init:)
		(StatusLine enable:)
		(= local80 -1)
		(StopEgo)
		(switch prevRoomNum
			(62
				(ego posn: 130 75 init: setMotion: MoveTo 130 85)
			)
			(71
				(ego posn: 318 140 init: setMotion: MoveTo 240 140)
			)
			(69
				(ego posn: 1 140 init: setMotion: MoveTo 35 140)
			)
			(else 
				(ego posn: 120 188 init: setMotion: MoveTo 120 170)
			)
		)
		(self setLocales: 804)
	)
	
	(method (doit)
		(cond 
			((== local69 70)
				(-- local69)
				(= local107 1)
				(= local82 (+ (= local80 local97) 8))
				(= local81 8)
				(rm70 setScript: faeryTalk)
			)
			((> local69 1) (-- local69))
			((== local69 1) (= local69 0))
		)
		(cond 
			((> local4 1) (-- local4))
			((== local4 1)
				(= local4 0)
				(= local107 1)
				(= local82 (+ (= local80 local91) 8))
				(= local81 2)
				(self setScript: faeryTalk)
			)
		)
		(if
			(and
				(== (ego onControl: 1) 16384)
				(== (User canControl:) 1)
				(not local87)
				fairiesOnScreen
			)
			(= local87 1)
			(localproc_00c8)
			(= local4 0)
			(= local107 1)
			(= local82 (+ (= local80 local96) 9))
			(= local81 7)
			(self setScript: faeryTalk)
		)
		(cond 
			((and (> local80 local89) (not local3)) (= local3 1))
			((and (== local81 8) (== (rm70 script?) 0))
				(= local107 1)
				(= local82 (+ (= local80 local92) 9))
				(= local81 3)
				(self setScript: faeryTalk)
			)
		)
		(super doit:)
	)
	
	(method (dispose &tmp temp0)
		(if fairiesOnScreen
			(DisposeDialog)
			(= temp0 0)
			(while (< temp0 5)
				([newAFaeryWindow temp0] dispose:)
				(++ temp0)
			)
		)
		(if local111 (HighPrint 70 0))
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if
		(and (== (pEvent type?) evJOYSTICK) (not local3))
			(pEvent claimed: 1)
			(= local3 1)
			(if (Btst DANCED_FOR_FAIRIES)
				(= local82 (+ (= local80 local106) 9))
				(= local81 17)
			else
				(= local82 (+ (= local80 local90) 12))
				(= local81 1)
			)
			(localproc_00c8)
			(self setScript: faeryTalk)
		)
		(if
		(and (== (pEvent type?) evMOUSEBUTTON) (not local3))
			(pEvent claimed: 1)
			(= local3 1)
			(if (Btst DANCED_FOR_FAIRIES)
				(= local82 (+ (= local80 local106) 9))
				(= local81 17)
			else
				(= local82 (+ (= local80 local90) 12))
				(= local81 1)
			)
			(localproc_00c8)
			(self setScript: faeryTalk)
		)
		(if
			(and
				(== (pEvent type?) evKEYBOARD)
				(== (pEvent message?) KEY_RETURN)
				script
			)
			(script cue:)
			(pEvent claimed: 1)
		)
		(if (== (pEvent type?) evSAID)
			(if (> local4 1)
				(cond 
					((Said 'affirmative,please,dance')
						(= local4 0)
						(= local107 1)
						(= local82 (+ (= local80 local91) 8))
						(= local81 2)
						(self setScript: faeryTalk)
					)
					((Said 'n')
						(= local4 0)
						(= local107 1)
						(= local82 (+ (= local80 local92) 9))
						(= local81 3)
						(self setScript: faeryTalk)
					)
					(else
						(HighPrint 70 1)
						;Don't you want to dance?
						(pEvent claimed: 1))
				)
			else
				(if (not local3)
					(pEvent claimed: 1)
					(= local3 1)
					(if (Btst 186)
						(= local82 (+ (= local80 local106) 9))
						(= local81 17)
					else
						(= local82 (+ (= local80 local90) 12))
						(= local81 1)
					)
					(localproc_00c8)
					(self setScript: faeryTalk)
				)
				(cond 
					((super handleEvent: pEvent))
					((Said 'dance')
						(if fairiesOnScreen
							(if (and (not script) (== (ego script?) 0))
								(ego setScript: cuteDance)
							)
						else
							(HighPrint 70 2)
							;What for?  There's no one to dance with.
						)
					)
					(
					(or (Said 'fight,kill,beat') (Said 'use/blade,dagger'))
						(if fairiesOnScreen
							(localproc_00c8)
							(= local107 1)
							(= local82 (+ (= local80 local105) 9))
							(= local81 16)
							(self setScript: faeryTalk)
						else
							(HighPrint 70 3)
							;What for?
						)
					)
					((Said 'chat')
						(if (and fairiesOnScreen (== local4 0))
							(if (Btst GOT_FAIRIES_ATTENTION)
								(= local107 1)
								(= local82 (+ (= local80 local104) 5))
								(= local81 15)
								(self setScript: faeryTalk)
							else
								(HighPrint 70 4)
								;They seem to be ignoring you.
							)
						else
							(HighPrint 70 5)
							;Who are you talking to?
						)
					)
					((Said 'ask>')
						(if (and fairiesOnScreen (== local4 0))
							(= local109 1)
							(cond 
								((Said '//mushroom,toadstool,ring')
									(localproc_00c8)
									(= local107 1)
									(= local82 (+ (= local80 local100) 8))
									(= local81 11)
									(self setScript: faeryTalk)
								)
								((Said '//dust[<faerie,about]')
									(if (or local88 (Btst POINTS_GETFAIRYDUST))
										(HighPrint 70 6)
										;You know all about it, now.
									else
										(localproc_00c8)
										(= local107 1)
										(= local82 (+ (= local80 local98) 22))
										(= local81 9)
										(self setScript: faeryTalk)
									)
								)
								((Said '//faerie,magic')
									(localproc_00c8)
									(= local107 1)
									(= local82 (+ (= local80 local101) 7))
									(= local81 12)
									(self setScript: faeryTalk)
								)
								((Said '//forest')
									(localproc_00c8)
									(= local107 1)
									(= local82 (+ (= local80 local102) 6))
									(= local81 13)
									(self setScript: faeryTalk)
								)
								((Said '//dryad')
									(localproc_00c8)
									(= local107 1)
									(= local82 (+ (= local80 local103) 6))
									(= local81 14)
									(self setScript: faeryTalk)
								)
								(else
									(pEvent claimed: 1)
									(= local109 0)
									(if (Btst GOT_FAIRIES_ATTENTION)
										(= local107 1)
										(= local82 (+ (= local80 local104) 5))
										(= local81 15)
										(self setScript: faeryTalk)
									else
										(HighPrint 70 4)
										;They seem to be ignoring you.
									)
								)
							)
							(if local109 (AddToScore POINTS_TALKTOFAIRIES 1))
						else
							(pEvent claimed: 0)
						)
					)
					((Said 'cast>')
						(switch (= temp0 (SaidCast pEvent))
							(18
								(if (CastSpell temp0)
									(if fairiesOnScreen
										(HighPrint 70 7)
										;There is much magic surrounding the fairies and their ring of mushrooms.
									else
										(HighPrint 70 8)
										;You detect faint emanations of magic near the ring of mushrooms.
									)
								)
							)
							(20
								(if (CastSpell temp0) (AnimateDazzle) (localproc_0143))
							)
							(22
								(if (CastSpell temp0) (AnimateCalm))
							)
							(23
								(if (CastSpell temp0)
									(AnimateThrowingFlameDart 0)
									(localproc_0143)
								)
							)
							(else  (pEvent claimed: 0))
						)
					)
					((Said 'throw/dagger,dagger')
						(if (ego has: invDagger)
							(AnimateThrowingDagger 0)
							(localproc_0143)
						else
							(HighPrint 70 9)
							;You don't have a dagger.
						)
					)
					((Said 'lockpick,get,gather/mushroom')
						(if (and (== local4 0) (== (ego script?) 0))
							(= local0 0)
							(ego setScript: pickEm)
						else
							(HighPrint 70 1)
							;Don't you want to dance?
						)
					)
					((Said 'eat/mushroom')
						(cond 
							((Btst ATE_FAIRY_MUSHROOMS) (pEvent claimed: 0))
							((and (== local4 0) (== (ego script?) 0)) (Bset 327) (ego setScript: eatShroom))
							(else (HighPrint 70 1)
								;Don't you want to dance?
								)
						)
					)
					((Said 'get>')
						(if (== local4 0)
							(cond 
								((Said '/faerie')
									(if fairiesOnScreen
										(HighPrint 70 10)
										;The fairies can avoid your grasp easily.
									else
										(HighPrint 70 11)
										;Huh?
									)
								)
								((Said '/dust[<faerie]')
									(cond 
										((Btst POINTS_GETFAIRYDUST)
											(HighPrint 70 12)
											;Don't be greedy.  We already gave you some.
											)
										(local88
											(HighPrint 70 13)
											;Perhaps you should be better prepared to get some fairy dust next time.
											)
										((not fairiesOnScreen)
											(HighPrint 70 14)
											;Where could you possibly get that?
											)
										((not local3)
											(HighPrint 70 15)
											;Maybe you should ask the Fairies for some.  That would be the polite thing to do.
											)
										(else
											(= local107 1)
											(= local82 (+ (= local80 local98) 22))
											(= local81 9)
											(self setScript: faeryTalk)
										)
									)
								)
							)
						else
							(HighPrint 70 1)
							;Don't you want to dance?
							(pEvent claimed: 1)
						)
					)
					((Said 'look>')
						(cond 
							(
							(Said '[<at,around][/!*,forest,greenery,clearing]')
							(HighPrint 70 16)
							;The trees look more vibrant than most of the forest.
							(HighPrint 70 17)
							;There is a ring of mushrooms on the northwest side of the clearing.
							)
							((Said '/ring,mushroom,toadstool')
								(if fairiesOnScreen
									(HighPrint 70 18)
									;The fairy ring is luminous at night.
								else
									(HighPrint 70 19)
									;The ring of mushrooms contains mushrooms slightly larger than the ones you are used to.
								)
							)
							((Said '/faerie,creature,chandelier')
								(if fairiesOnScreen
									(HighPrint 70 20)
									;The fairies look like little dancing lights, but you get a strong sense that they are female with butterfly wings.
								else
									(HighPrint 70 21)
									;There aren't any of those around.
								)
							)
							((Said '/south')
								(HighPrint 70 22)
								;The trees seem more dense and lush than the rest of the woods.
								)
							((Said '/tree')
								(HighPrint 70 16)
								;The trees look more vibrant than most of the forest.
								)
							((Said '/east,north')
								(HighPrint 70 23)
								;You see trees and brush.
								)
							((Said '/west')
								(HighPrint 70 24)
								;The trees here look thicker and healthier than in other parts of the forest.
								)
						)
					)
				)
			)
		)
	)
)

(instance aFaeryScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (> local69 0)
					(client
						setMotion:
							MoveTo
							(Random
								(- [local70 register] 25)
								(+ [local70 register] 25)
							)
							(Random
								(- [local75 register] 25)
								(+ [local75 register] 25)
							)
							self
					)
				else
					(client
						setMotion:
							MoveTo
							(Random
								(- [local34 register] 15)
								(+ [local34 register] 15)
							)
							(Random
								(- [local39 register] 15)
								(+ [local39 register] 15)
							)
							self
					)
				)
			)
			(1 (self changeState: 0))
		)
	)
)

(instance aChaseScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(cond 
					(local108
						(client
							setMotion:
								MoveTo
								(- (Random (ego x?) (+ (ego x?) 8)) 18)
								(- (Random (ego y?) (+ (ego y?) 8)) 16)
								self
						)
					)
					((Btst DANCING_FOR_FAIRIES)
						(client
							setMotion:
								MoveTo
								(- (Random (ego x?) (+ (ego x?) 20)) 10)
								(- (Random (ego y?) (+ (ego y?) 30)) 15)
								self
						)
					)
					(else
						(client
							setMotion:
								MoveTo
								(- (Random (ego x?) (+ (ego x?) 80)) 40)
								(- (Random (ego y?) (+ (ego y?) 30)) 15)
								self
						)
					)
				)
			)
			(1 (self changeState: 0))
		)
	)
)

(instance faeryTalk of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (not isEgoLocked) (LockEgo))
				(= seconds (if local107 4 else 3))
				(FairySays seconds 296 local80)
			)
			(1
				(= local107 0)
				(= seconds 0)
				(++ local80)
				(cond 
					(
						(or
							(and local87 (== local80 (+ local96 7)))
							(and (== local81 3) (== local80 (+ local92 7)))
							(and (== local81 16) (== local80 (+ local105 7)))
						)
						(ego setScript: deathDance)
						(self changeState: 0)
					)
					((< local80 local82) (self changeState: 0))
					(else
						(switch local81
							(1
								(Bset DANCED_FOR_FAIRIES)
								(= local4 100)
								(UnlockEgo)
							)
							(17 (= local4 100) (UnlockEgo))
							(2 (ego setScript: cuteDance))
							(5 (= local84 1))
							(4 (= local84 1))
							(8
								(= local69 0)
								(localproc_00c8)
							)
							(9 (ego setScript: getDust))
							(10 (getDust cue:))
							(15 (localproc_0106))
						)
						(if (== (ego script?) 0) (DisposeDialog) (UnlockEgo))
						(self dispose:)
					)
				)
			)
		)
	)
)

(instance cuteDance of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(AddToScore POINTS_DANCEWITHFAIRIES 3)
				(localproc_0106)
				(ego
					illegalBits: 0
					ignoreActors:
					setMotion: MoveTo local85 local86 self
				)
			)
			(1
				(if (TestSkill skAGILITY 25)
					(self cue:)
				else
					(ego setScript: klutzDance)
					(egoBoogie play:)
				)
			)
			(2
				(ego
					view: 71
					setLoop: 6
					cel: 0
					cycleSpeed: 1
					moveSpeed: 3
					setCycle: Forward
				)
				(self cue:)
			)
			(3
				(++ local83)
				(ego
					setMotion:
						MoveTo
						(Random (- local85 20) (+ local85 20))
						(Random (- local86 10) (+ local86 10))
						self
				)
			)
			(4
				(cond 
					((== local83 2) (Bset 187) (localproc_00c8) (self changeState: 3))
					((== local83 3)
						(= local107 1)
						(= local82 (+ (= local80 local94) 9))
						(= local81 5)
						(rm70 setScript: faeryTalk)
						(self changeState: 3)
					)
					(local84 (= local84 0) (self cue:))
					((>= local83 40) (self changeState: 13))
					(else (self changeState: 3))
				)
			)
			(5
				(localproc_0106)
				(ego setLoop: 5 cel: 0 setCycle: 0)
				(= seconds 2)
			)
			(6
				(ego setCycle: EndLoop)
				(= cycles 10)
			)
			(7
				(ego setCycle: BegLoop)
				(= cycles 10)
			)
			(8
				(ego x: (+ (ego x?) 12) setLoop: 4 cel: 0 setCycle: EndLoop)
				(= cycles 10)
			)
			(9
				(FairySays 2 {Wow!})
				(= seconds 2)
			)
			(10 (ego setCycle: BegLoop self))
			(11
				(StopEgo)
				(ego x: (- (ego x?) 12) loop: 2)
				(= cycles 5)
			)
			(12
				(Bclr DANCING_FOR_FAIRIES)
				(localproc_00c8)
				(= local107 1)
				(= local82 (+ (= local80 local95) 11))
				(= local81 6)
				(rm70 setScript: faeryTalk)
				(UnlockEgo)
				(self dispose:)
			)
			(13
				(HighPrint 70 25)
				;I'll bet you're sorry you said that.
				(= local83 0)
				(UnlockEgo)
				(StopEgo)
				(ego x: (- (ego x?) 12) loop: 2)
				(self dispose:)
			)
		)
	)
)

(instance klutzDance of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ego
					view: 71
					setLoop: (Random 0 4)
					cel: 0
					cycleSpeed: (if local87 0 else 1)
					setCycle: EndLoop self
				)
				(++ local83)
			)
			(1
				(cond 
					((== local83 5)
						(= local107 1)
						(= local82 (+ (= local80 local93) 5))
						(= local81 4)
						(rm70 setScript: faeryTalk)
						(self changeState: 0)
					)
					(local84 (= local84 0) (egoBoogie stop:) (self cue:))
					((>= local83 40) (self changeState: 4))
					(else (self changeState: 0))
				)
			)
			(2
				(UnlockEgo)
				(StopEgo)
				(ego x: (- (ego x?) 12) loop: 2)
				(= cycles 10)
			)
			(3
				(localproc_00c8)
				(= local107 1)
				(= local82 (+ (= local80 local95) 11))
				(= local81 6)
				(rm70 setScript: faeryTalk)
				(self dispose:)
			)
			(4
				(HighPrint 70 25)
				(= local83 0)
				(UnlockEgo)
				(StopEgo)
				(ego x: (- (ego x?) 12) loop: 2)
				(self dispose:)
			)
		)
	)
)

(instance deathDance of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local83 0)
				(ego
					illegalBits: 0
					ignoreActors:
					setMotion: MoveTo 94 102 self
				)
			)
			(1
				(faeryMusic stop:)
				(bopTilYouDrop play:)
				(ego view: 71 x: (+ (ego x?) 12))
				(self cue:)
			)
			(2
				(ego setLoop: (Random 0 4) cel: 0 setCycle: EndLoop self)
				(++ local83)
			)
			(3
				(cond 
					((== (mod local83 3) 0) (FairySays 2 {Dance!}) (self changeState: 2))
					((== local83 19) (self cue:))
					(else (self changeState: 2))
				)
			)
			(4
				(bopTilYouDrop stop:)
				(ego setLoop: 7 setCel: 1)
				(= cycles 10)
			)
			(5
				(ego cycleSpeed: 1 setCycle: EndLoop)
				(= cycles 35)
			)
			(6
				(FairySays 4 {He's no fun!__He fell right over!})
				(= seconds 4)
			)
			(7
				(Die 70 26
					#title {Land of 1000 Dances}
					#icon 71 2 5)
					;For such wimpy-looking creatures, those fairies sure can play rough!
					;You never danced so hard in your entire life, which is now over.
			)
		)
	)
)

(instance pickEm of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(if (> (ego x?) 92)
					(ego illegalBits: 0 setMotion: MoveTo 175 109 self)
				else
					(ego illegalBits: 0 setMotion: MoveTo 19 109 self)
				)
			)
			(1
				(ego
					view: 510
					setLoop: (if (< (ego x?) 100) 0 else 1)
					cel: 0
					setCycle: EndLoop self
				)
			)
			(2
				(if local0
					(PrintTimedMessage 4 70 27)
					;You eat a few of the lovely mushrooms.
				else
					(HighPrint 70 28)
					;You pick a handful of the smaller mushrooms and carefully put them away in your backpack.
					(ego get: invMushroom 3)
					(Bset HAVE_FAIRY_MUSHROOMS)
					(AddToScore POINTS_PICKMUSHROOMS 3)
				)
				(ego setCycle: BegLoop self)
			)
			(3
				(StopEgo)
				(ego loop: 2)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)

(instance getDust of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(LockEgo)
				(= local88 1)
				(ego view: 72 loop: 0 cel: 0 setCycle: CycleTo 3 1 self)
			)
			(1
				(PrintTimedMessage 5 70 29)
				;You hold out your hand...what else could you do?
				(= local108 1)
				(= seconds 6)
			)
			(2
				(= local81 10)
				(= local107 1)
				(= local82 (+ (= local80 local99) 3))
				(rm70 setScript: faeryTalk)
			)
			(3
				(= cycles 10)
				(= local108 0)
			)
			(4
				(cond 
					((ego has: 26)
						(PrintTimedMessage 8 70 30)
						;You place the dust carefully away in an empty flask.
						(ego use: invEmptyFlask 1)
						(ego get: invFairyDust)
						(AddToScore POINTS_GETFAIRYDUST 8)
					)
					(
						(or
							(ego has: invHealingPotion)
							(ego has: invManaPotion)
							(ego has: invVigorPotion)
							(ego has: invUndeadUnguent)
						)
						(PrintTimedMessage 8 70 31)
						;You realize that you need something such as an empty flask to put this fairy dust into.
					)
					(else
						(PrintTimedMessage 8 70 32)
						;As the fairy dust sifts through your fingers, you realize that you needed something to put it into.
						)
				)
				(= seconds 8)
			)
			(5
				(ego setCycle: EndLoop)
				(= cycles 15)
			)
			(6
				(StopEgo)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)

(instance eatShroom of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local0 1)
				(self setScript: pickEm self)
			)
			(1
				(LockEgo)
				(= mushroomPalette defaultPalette)
				(= defaultPalette 2)
				(DrawPic (curRoom curPic?) 100 dpCLEAR defaultPalette)
				(Animate (gCast elements?) 0)
				(= seconds 3)
			)
			(2
				(HighPrint 70 33)
				;Wow!  That was pretty wild!  It's probably not a good idea to eat too many more of these mushrooms, though.
				(= local111 1)
				(= defaultPalette mushroomPalette)
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)
