;;; Sierra Script 1.0 - (do not remove this comment)
(script# 12)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use RandomEncounter)
(use Motion)
(use Game)
(use Actor)
(use System)

(public
	rm12 0
)

(instance rm12 of EncRoom
	(properties
		picture 700
		style $0008
		horizon 90
		north 10
		east 13
		west 11
		encChance 30
		entrances 6
		illBits -28672
	)
	
	(method (init)
		(Load rsVIEW 700)
		(super init:)
		(StatusLine enable:)
		(self setLocales: 804)
		(StopEgo)
		(ego illegalBits: -28672)
		(if (not monsterInRoom) (ego init:))
		(switch prevRoomNum
			(10
				(ego posn: 140 91 setMotion: MoveTo 140 190)
			)
			(11
				(ego posn: 0 140 setMotion: MoveTo 320 140)
			)
			(13
				(ego posn: 319 140 setMotion: MoveTo 0 140)
			)
		)
		(gAddToPics add: southBush eachElementDo: #init doit:)
		(if
			(not
				(OneOf
					prevRoomNum
					420 425 430 435 440 445 450 455 460 465 470
				)
			)
			(= gGEgoObjX (ego x?))
			(= gGEgoObjY (ego y?))
		)
		(self setRegions: 210)
	)
	
	(method (dispose)
		(Bset VISITED_FOREST_12)
		(super dispose:)
	)
)

(instance southBush of PicView
	(properties
		y 207
		x 162
		view 700
		loop 2
		cel 1
		priority 15
	)
)
