;;; Sierra Script 1.0 - (do not remove this comment)
(script# 117)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use KoboldCave)
(use Motion)

(public
	startFight 0
	stopFight 1
)

(instance startFight of KScript
	(properties)
	
	(method (dispose)
		(= global289 0)
		(super dispose:)
		(DisposeScript 117)
	)
	
	(method (changeState newState &tmp theEgoKoboldBattleLoop)
		(switch (= state newState)
			(0
				(= global289 1)
				(= fightingKobold 0)
				(LockEgo)
				(ChangeEgoWalk MOVE_WALK 0)
				(ego illegalBits: 0)
				(if
					(<
						(= global344
							(-
								(/
									(+
										(* [skills skWEAPONUSE] 8)
										(* [skills skAGILITY] 4)
										(* [skills skSTRENGTH] 2)
										[skills skINTELLIGENCE]
										[skills skLUCK]
									)
									16
								)
								20
							)
						)
						5
					)
					(= global344 5)
				)
				(= global345 (+ 9 (/ [skills skSTRENGTH] 10)))
				(if (ego has: invBroadsword) (= global345 (+ global345 3)))
				(if (< (ego y?) 105)
					(self cue:)
				else
					(ego setMotion: MoveTo 160 (ego y?) self)
				)
			)
			(1
				(if egoKoboldBattleLoop
					(ego setMotion: MoveTo 111 96 self)
				else
					(ego setMotion: MoveTo 172 94 self)
				)
			)
			(2
				(= theEgoKoboldBattleLoop egoKoboldBattleLoop)
				(if (not (ego has: invBroadsword))
					(= theEgoKoboldBattleLoop (+ theEgoKoboldBattleLoop 2))
				)
				(ego
					view: 502
					setLoop: theEgoKoboldBattleLoop
					cycleSpeed: 1
					setCycle: EndLoop self
				)
			)
			(3
				(client setScript: (ScriptID 15 8))
			)
		)
	)
)

(instance stopFight of KScript
	(properties)
	
	(method (dispose)
		(super dispose:)
		(DisposeScript 117)
	)
	
	(method (changeState newState &tmp theEgoKoboldBattleLoop)
		(switch (= state newState)
			(0
				(LockEgo)
				(= fightingKobold FALSE)
				(= theEgoKoboldBattleLoop egoKoboldBattleLoop)
				(if (not (ego has: invBroadsword))
					(= theEgoKoboldBattleLoop (+ theEgoKoboldBattleLoop 2))
				)
				(ego
					view: 502
					setLoop: theEgoKoboldBattleLoop
					cel: (ego lastCel:)
					setCycle: BegLoop self
				)
			)
			(1
				(StopEgo)
				(ego loop: egoKoboldBattleLoop)
				(if (not (Btst DEFEATED_KOBOLD)) (ego illegalBits: global282))
				(UnlockEgo)
				(self dispose:)
			)
		)
	)
)
