;;; Sierra Script 1.0 - (do not remove this comment)
(script# 5)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Inventory)

(public
	Drink 0
)

(procedure (Drink param1 param2 &tmp temp0)
	(if param2
		(= temp0 param2)
	else
		(= temp0 (SaidGet param1))
	)
	(cond 
		((not temp0)
			(param1 claimed: 0)
			(cond 
				((Said '/water') ;Bugged for some reason; claims "That isn't drinkable."
					(if (ego has: invWater)
						(ego use: invWater 1)
						(ego get: invEmptyFlask)
						(cond 
							((not (ego has: invWater)) (Bclr 330) (Bclr 329))
							((Btst 330) (Bclr 330))
							((Btst 329) (Bclr 329))
						)
						(HighPrint 5 0)
						;You drink a flask of water.  It tastes great.
						(HighPrint 5 1)
						;(Less filling, too!)
					)
				)
				((Said '/potion')
					(= temp0 0)
					(= param2 invHealingPotion)
					(while (<= param2 invUndeadUnguent)
						(cond 
							((and [invNum param2] (not temp0)) (= temp0 param2))
							((and temp0 [invNum param2]) (= temp0 -1) (break))
						)
						(++ param2)
					)
					(switch temp0
						(-1 
							(HighPrint 5 2)
							;Perhaps you could tell me which potion you want to drink.							
						)
						(0
							(HighPrint 5 3)
							;You have no potions.	
						)
						(else  (Drink param1 temp0))
					)
				)
				(else (param1 claimed: 1)
					(HighPrint 5 4)
					;You don't see any here.
				)
			)
		)
		((or (< temp0 invHealingPotion) (> temp0 invUndeadUnguent))
			(param1 claimed: 0)
			(if (Said 'drink')
				(HighPrint 5 5)
				;That isn't drinkable.
			else
				(HighPrint 5 6)
				;It's not clear how you want to use that.
			)
			(param1 claimed: 1)
		)
		((not [invNum temp0]) (HighPrint 5 7))
		((== temp0 invHealingPotion)
			(HighPrint 5 8)
			;The drink soothes as it goes down.
			(ReduceHP (- (/ (GetMaxHealth) 2)))
			(ego use: invHealingPotion)
			(ego get: invEmptyFlask)
		)
		((== temp0 invManaPotion)
			(HighPrint 5 9)
			;The drink burns as it goes down.
			(ReduceMP (- (/ (GetMaxMana) 2)))
			(ego use: invManaPotion)
			(ego get: invEmptyFlask)
		)
		((== temp0 invVigorPotion)
			(HighPrint 5 10)
			;The drink is invigorating.
			(ReduceSP (- (GetMaxStamina)))
			(ego use: invVigorPotion)
			(ego get: invEmptyFlask)
		)
		((== temp0 invDispelPotion)
			(HighPrint 5 11)
			;You don't feel anything.  Perhaps this was not the correct way to use this potion.
			(ego use: invDispelPotion)
			(ego get: invEmptyFlask)
			(param1 claimed: 1)
		)
		((== temp0 invUndeadUnguent)
			(if (ego has: invUndeadUnguent)
				(HighPrint 5 12)
				;You feel a tingling sensation as you rub the unguent all over your body.
				(Bset PROTECTED_UNGUENT)
				(Bclr GHOSTS_ATTACK)
				(= undeadUnguentTimer 150)
				(ego use: invUndeadUnguent)
				(ego get: invEmptyFlask)
			else
				(HighPrint 5 13)
				;You can't.  You don't have any.
			)
		)
	)
	(DisposeScript 5)
)
