;;; Sierra Script 1.0 - (do not remove this comment)
(script# 100)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use TargActor)
(use LoadMany)
(use Sound)
(use Motion)
(use Actor)
(use System)

(public
	AnimateThrowingFlameDart 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	gEgoObjSignal
	gEgoObjPriority
	gEgoObjIllegalBits
	newAct
)
(procedure (AnimateThrowingFlameDart param1 &tmp temp0 temp1 newAct_2)
	(LoadMany 132 (GetSongNumber 33) (GetSongNumber 45))
	(Load rsVIEW 522)
	(if param1
		(FaceObject ego param1)
		(= local3 (+ (param1 x?) (param1 targDeltaX?)))
		(= local4 (+ (param1 y?) (param1 targDeltaY?)))
		(= temp0 (- local3 (ego x?)))
		(= temp1 (- local4 (- (ego y?) 20)))
		(while
			(and
				(< 0 local3)
				(< local3 319)
				(< 0 local4)
				(< local4 189)
			)
			(= local3 (+ local3 temp0))
			(= local4 (+ local4 temp1))
		)
		(if
			(and
				(param1 isKindOf: TargActor)
				(not
					(TestSkill 12 0 (- 50 (/ (ego distanceTo: param1) 5)))
				)
			)
			(if (< local4 0)
				(= local4 (+ local4 (Random 30 100)))
			else
				(= local4 (- local4 (Random 30 100)))
			)
		)
	else
		(UseSkill skTHROWING (/ [skills skAGILITY] 10))
		(= local3 (if (== (ego loop?) 1) -10 else 330))
		(= local4 (Random 20 80))
	)
	((= newAct (Sound new:))
		number: (GetSongNumber 33)
		priority: 15
		init:
	)
	(= local0 param1)
	((= newAct_2 (Actor new:))
		view: 522
		setLoop: 2
		setCel: 0
		illegalBits: 0
		ignoreActors:
		ignoreHorizon:
		z: 20
		posn: (ego x?) (- (ego y?) 6)
		setStep: 12 8
		init:
		hide:
		setScript: dartScript 0 param1
	)
	(return 1)
)

(instance dartScript of Script
	(properties)
	
	(method (doit &tmp temp0)
		(asm
			pushi    1
			lsl      local0
			callk    IsObject,  2
			bnt      code_021d
			pushi    #x
			pushi    0
			lal      local0
			send     4
			push    
			pushi    #targDeltaX
			pushi    0
			lal      local0
			send     4
			add     
			sal      local3
			pushi    #y
			pushi    0
			lal      local0
			send     4
			push    
			pushi    #targDeltaY
			pushi    0
			lal      local0
			send     4
			add     
			sal      local4
code_021d:
			pushi    #x
			pushi    0
			pToa     client
			send     4
			push    
			lal      local3
			sub     
			sal      local1
			pushi    #y
			pushi    0
			pToa     client
			send     4
			push    
			lal      local4
			sub     
			sal      local2
			pTos     state
			ldi      1
			eq?     
			bnt      code_02b3
			pushi    65511
			lal      local1
			lt?     
			bnt      code_025a
			pprev   
			ldi      25
			lt?     
			bnt      code_025a
			pushi    65511
			lal      local2
			lt?     
			bnt      code_025a
			pprev   
			ldi      25
			lt?     
code_025a:
			sat      temp0
			bt       code_02a2
			pushi    #mover
			pushi    0
			pToa     client
			send     4
			not     
			bt       code_02a2
			pushi    4
			dup     
			pushi    0
			pToa     client
			send     4
			push    
			pushi    #y
			pushi    0
			pToa     client
			send     4
			push    
			lsl      local3
			lsl      local4
			callk    GetDistance,  8
			push    
			pushi    25
			pushi    4
			dup     
			pushi    0
			lag      ego
			send     4
			push    
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			lsl      local3
			lsl      local4
			callk    GetDistance,  8
			add     
			gt?     
			bnt      code_02b3
code_02a2:
			pToa     register
			bnt      code_02a9
			lat      temp0
code_02a9:
			sal      local5
			pushi    #cue
			pushi    0
			self     4
			jmp      code_02b9
code_02b3:
			pushi    #doit
			pushi    0
			super    Script,  4
code_02b9:
			ret     
		)
	)
	
	(method (dispose)
		(newAct dispose:)
		(UnlockEgo)
		(if (and local5 (IsObject register))
			(register getHurt: (+ 5 (/ [skills skFLAMEDART] 3)))
		)
		(super dispose:)
		(DisposeScript 100)
	)
	
	(method (changeState newState &tmp [temp0 2])
		(switch (= state newState)
			(0
				(= gEgoObjSignal (ego signal?))
				(= gEgoObjPriority (ego priority?))
				(= gEgoObjIllegalBits (ego illegalBits?))
				(LockEgo)
				(ego
					view: 522
					setLoop: (if (or (== (ego loop?) 1) (== (ego loop?) 3))
						1
					else
						0
					)
					cel: 0
					setCycle: CycleTo 5 1 self
				)
			)
			(1
				(ego setCycle: EndLoop)
				(newAct play:)
				(client
					x: (if (== (ego loop?) 1)
						(- (ego x?) 19)
					else
						(+ (ego x?) 19)
					)
					show:
					setCycle: Forward
					setMotion: MoveTo local3 local4
				)
			)
			(2
				(if local5
					(newAct stop: number: (GetSongNumber 45) play:)
					(client setLoop: 3 cel: 0 setMotion: 0 setCycle: EndLoop self)
				else
					(client hide:)
					(= cycles 1)
				)
			)
			(3
				(StopEgo)
				(ego
					priority: gEgoObjPriority
					illegalBits: gEgoObjIllegalBits
					signal: gEgoObjSignal
				)
				(client dispose:)
			)
		)
	)
)
